=== modified file 'Changelog'
--- Changelog	2012-12-21 16:06:34 +0000
+++ Changelog	2012-12-21 17:38:09 +0000
@@ -1,5 +1,7 @@
 Changelog for Percona Toolkit
 
+v2.1.8 released 2012-12-21
+
   * Fixed bug 1086259: pt-kill --log-dsn timestamp is wrong
   * Fixed bug 1082104: pt-deadlock-logger problem when the user have a dash in the name
   * Fixed bug 1079341: pt-online-schema-change checks for foreign keys on myisam tables.

=== modified file 'Makefile.PL'
--- Makefile.PL	2012-11-19 18:47:13 +0000
+++ Makefile.PL	2012-12-21 17:38:09 +0000
@@ -2,7 +2,7 @@
 
 WriteMakefile(
     NAME      => 'percona-toolkit',
-    VERSION   => '2.1.7',
+    VERSION   => '2.1.8',
     EXE_FILES => [ <bin/*> ],
     MAN1PODS  => {
       'docs/percona-toolkit.pod' => 'blib/man1/percona-toolkit.1p',

=== modified file 'bin/pt-align'
--- bin/pt-align	2012-11-19 18:47:13 +0000
+++ bin/pt-align	2012-12-21 17:38:09 +0000
@@ -218,6 +218,6 @@
 
 =head1 VERSION
 
-pt-align 2.1.7
+pt-align 2.1.8
 
 =cut

=== modified file 'bin/pt-archiver'
--- bin/pt-archiver	2012-12-11 14:48:44 +0000
+++ bin/pt-archiver	2012-12-21 17:38:09 +0000
@@ -39,7 +39,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -7574,6 +7574,6 @@
 
 =head1 VERSION
 
-pt-archiver 2.1.7
+pt-archiver 2.1.8
 
 =cut

=== modified file 'bin/pt-config-diff'
--- bin/pt-config-diff	2012-12-11 14:48:44 +0000
+++ bin/pt-config-diff	2012-12-21 17:38:09 +0000
@@ -38,7 +38,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -4872,6 +4872,6 @@
 
 =head1 VERSION
 
-pt-config-diff 2.1.7
+pt-config-diff 2.1.8
 
 =cut

=== modified file 'bin/pt-deadlock-logger'
--- bin/pt-deadlock-logger	2012-12-20 16:54:36 +0000
+++ bin/pt-deadlock-logger	2012-12-21 17:38:09 +0000
@@ -36,7 +36,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -4785,6 +4785,6 @@
 
 =head1 VERSION
 
-pt-deadlock-logger 2.1.7
+pt-deadlock-logger 2.1.8
 
 =cut

=== modified file 'bin/pt-diskstats'
--- bin/pt-diskstats	2012-12-03 03:48:11 +0000
+++ bin/pt-diskstats	2012-12-21 17:38:09 +0000
@@ -38,7 +38,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -1240,6 +1240,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -5567,6 +5570,6 @@
 
 =head1 VERSION
 
-pt-diskstats 2.1.7
+pt-diskstats 2.1.8
 
 =cut

=== modified file 'bin/pt-duplicate-key-checker'
--- bin/pt-duplicate-key-checker	2012-12-20 23:05:06 +0000
+++ bin/pt-duplicate-key-checker	2012-12-21 17:38:09 +0000
@@ -39,7 +39,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -5435,6 +5435,6 @@
 
 =head1 VERSION
 
-pt-duplicate-key-checker 2.1.7
+pt-duplicate-key-checker 2.1.8
 
 =cut

=== modified file 'bin/pt-fifo-split'
--- bin/pt-fifo-split	2012-12-03 03:48:11 +0000
+++ bin/pt-fifo-split	2012-12-21 17:38:09 +0000
@@ -1568,6 +1568,6 @@
 
 =head1 VERSION
 
-pt-fifo-split 2.1.7
+pt-fifo-split 2.1.8
 
 =cut

=== modified file 'bin/pt-find'
--- bin/pt-find	2012-12-03 03:48:11 +0000
+++ bin/pt-find	2012-12-21 17:38:09 +0000
@@ -35,7 +35,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -4898,6 +4898,6 @@
 
 =head1 VERSION
 
-pt-find 2.1.7
+pt-find 2.1.8
 
 =cut

=== modified file 'bin/pt-fingerprint'
--- bin/pt-fingerprint	2012-12-03 03:48:11 +0000
+++ bin/pt-fingerprint	2012-12-21 17:38:09 +0000
@@ -2148,6 +2148,6 @@
 
 =head1 VERSION
 
-pt-fingerprint 2.1.7
+pt-fingerprint 2.1.8
 
 =cut

=== modified file 'bin/pt-fk-error-logger'
--- bin/pt-fk-error-logger	2012-12-20 16:55:12 +0000
+++ bin/pt-fk-error-logger	2012-12-21 17:38:09 +0000
@@ -35,7 +35,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -4030,6 +4030,6 @@
 
 =head1 VERSION
 
-pt-fk-error-logger 2.1.7
+pt-fk-error-logger 2.1.8
 
 =cut

=== modified file 'bin/pt-heartbeat'
--- bin/pt-heartbeat	2012-12-14 01:38:40 +0000
+++ bin/pt-heartbeat	2012-12-21 17:38:09 +0000
@@ -38,7 +38,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -3168,6 +3168,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -6045,6 +6048,6 @@
 
 =head1 VERSION
 
-pt-heartbeat 2.1.7
+pt-heartbeat 2.1.8
 
 =cut

=== modified file 'bin/pt-index-usage'
--- bin/pt-index-usage	2012-12-20 23:05:06 +0000
+++ bin/pt-index-usage	2012-12-21 17:38:09 +0000
@@ -45,7 +45,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -2713,14 +2713,25 @@
 
             if ( !$found_arg && $pos == $len ) {
                PTDEBUG && _d("Did not find arg, looking for special cases");
-               local $INPUT_RECORD_SEPARATOR = ";\n";
+               local $INPUT_RECORD_SEPARATOR = ";\n";  # get next line
                if ( defined(my $l = $next_event->()) ) {
-                  chomp $l;
-                  $l =~ s/^\s+//;
-                  PTDEBUG && _d("Found admin statement", $l);
-                  push @properties, 'cmd', 'Admin', 'arg', $l;
-                  push @properties, 'bytes', length($properties[-1]);
-                  $found_arg++;
+                  if ( $l =~ /^\s*[A-Z][a-z_]+: / ) {
+                     PTDEBUG && _d("Found NULL query before", $l);
+                     local $INPUT_RECORD_SEPARATOR = ";\n#";
+                     my $rest_of_event = $next_event->();
+                     push @{$self->{pending}}, $l . $rest_of_event;
+                     push @properties, 'cmd', 'Query', 'arg', '/* No query */';
+                     push @properties, 'bytes', 0;
+                     $found_arg++;
+                  }
+                  else {
+                     chomp $l;
+                     $l =~ s/^\s+//;
+                     PTDEBUG && _d("Found admin statement", $l);
+                     push @properties, 'cmd', 'Admin', 'arg', $l;
+                     push @properties, 'bytes', length($properties[-1]);
+                     $found_arg++;
+                  }
                }
                else {
                   PTDEBUG && _d("I can't figure out what to do with this line");
@@ -3349,6 +3360,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -7469,6 +7483,6 @@
 
 =head1 VERSION
 
-pt-index-usage 2.1.7
+pt-index-usage 2.1.8
 
 =cut

=== modified file 'bin/pt-ioprofile'
--- bin/pt-ioprofile	2012-11-19 18:47:13 +0000
+++ bin/pt-ioprofile	2012-12-21 17:38:09 +0000
@@ -69,7 +69,7 @@
 usage() {
    local file="$1"
 
-   local usage=$(grep '^Usage: ' "$file")
+   local usage="$(grep '^Usage: ' "$file")"
    echo $usage
    echo
    echo "For more information, 'man $TOOL' or 'perldoc $file'."
@@ -1103,7 +1103,7 @@
 
 =head1 VERSION
 
-pt-ioprofile 2.1.7
+pt-ioprofile 2.1.8
 
 =cut
 

=== modified file 'bin/pt-kill'
--- bin/pt-kill	2012-12-11 14:51:01 +0000
+++ bin/pt-kill	2012-12-21 17:38:09 +0000
@@ -43,7 +43,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -2275,6 +2275,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -7786,6 +7789,6 @@
 
 =head1 VERSION
 
-pt-kill 2.1.7
+pt-kill 2.1.8
 
 =cut

=== modified file 'bin/pt-log-player'
--- bin/pt-log-player	2012-12-20 17:52:09 +0000
+++ bin/pt-log-player	2012-12-21 17:38:09 +0000
@@ -1193,14 +1193,25 @@
 
             if ( !$found_arg && $pos == $len ) {
                PTDEBUG && _d("Did not find arg, looking for special cases");
-               local $INPUT_RECORD_SEPARATOR = ";\n";
+               local $INPUT_RECORD_SEPARATOR = ";\n";  # get next line
                if ( defined(my $l = $next_event->()) ) {
-                  chomp $l;
-                  $l =~ s/^\s+//;
-                  PTDEBUG && _d("Found admin statement", $l);
-                  push @properties, 'cmd', 'Admin', 'arg', $l;
-                  push @properties, 'bytes', length($properties[-1]);
-                  $found_arg++;
+                  if ( $l =~ /^\s*[A-Z][a-z_]+: / ) {
+                     PTDEBUG && _d("Found NULL query before", $l);
+                     local $INPUT_RECORD_SEPARATOR = ";\n#";
+                     my $rest_of_event = $next_event->();
+                     push @{$self->{pending}}, $l . $rest_of_event;
+                     push @properties, 'cmd', 'Query', 'arg', '/* No query */';
+                     push @properties, 'bytes', 0;
+                     $found_arg++;
+                  }
+                  else {
+                     chomp $l;
+                     $l =~ s/^\s+//;
+                     PTDEBUG && _d("Found admin statement", $l);
+                     push @properties, 'cmd', 'Admin', 'arg', $l;
+                     push @properties, 'bytes', length($properties[-1]);
+                     $found_arg++;
+                  }
                }
                else {
                   PTDEBUG && _d("I can't figure out what to do with this line");
@@ -1559,7 +1570,8 @@
                $cmd = $arg;
             }
             else {
-               my ($user, undef, $db) = $arg =~ /(\S+)/g;
+               my ($user) = $arg =~ m/(\S+)/;
+               my ($db)   = $arg =~ m/on (\S+)/;
                my $host;
                ($user, $host) = split(/@/, $user);
                PTDEBUG && _d('Connect', $user, '@', $host, 'on', $db);
@@ -3662,6 +3674,6 @@
 
 =head1 VERSION
 
-pt-log-player 2.1.7
+pt-log-player 2.1.8
 
 =cut

=== modified file 'bin/pt-mext'
--- bin/pt-mext	2012-11-19 18:47:13 +0000
+++ bin/pt-mext	2012-12-21 17:38:09 +0000
@@ -282,7 +282,7 @@
 
 =head1 VERSION
 
-pt-mext 2.1.7
+pt-mext 2.1.8
 
 =cut
 

=== modified file 'bin/pt-mysql-summary'
--- bin/pt-mysql-summary	2012-12-07 18:52:33 +0000
+++ bin/pt-mysql-summary	2012-12-21 17:38:09 +0000
@@ -3002,7 +3002,7 @@
 
 =head1 VERSION
 
-pt-mysql-summary 2.1.7
+pt-mysql-summary 2.1.8
 
 =cut
 

=== modified file 'bin/pt-online-schema-change'
--- bin/pt-online-schema-change	2012-12-11 17:31:22 +0000
+++ bin/pt-online-schema-change	2012-12-21 17:38:09 +0000
@@ -51,7 +51,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -5835,6 +5835,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -10849,6 +10852,6 @@
 
 =head1 VERSION
 
-pt-online-schema-change 2.1.7
+pt-online-schema-change 2.1.8
 
 =cut

=== modified file 'bin/pt-pmp'
--- bin/pt-pmp	2012-11-19 18:47:13 +0000
+++ bin/pt-pmp	2012-12-21 17:38:09 +0000
@@ -396,7 +396,7 @@
 
 =head1 VERSION
 
-pt-pmp 2.1.7
+pt-pmp 2.1.8
 
 =cut
 

=== modified file 'bin/pt-query-advisor'
--- bin/pt-query-advisor	2012-12-11 14:48:44 +0000
+++ bin/pt-query-advisor	2012-12-21 17:38:09 +0000
@@ -46,7 +46,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -1727,14 +1727,25 @@
 
             if ( !$found_arg && $pos == $len ) {
                PTDEBUG && _d("Did not find arg, looking for special cases");
-               local $INPUT_RECORD_SEPARATOR = ";\n";
+               local $INPUT_RECORD_SEPARATOR = ";\n";  # get next line
                if ( defined(my $l = $next_event->()) ) {
-                  chomp $l;
-                  $l =~ s/^\s+//;
-                  PTDEBUG && _d("Found admin statement", $l);
-                  push @properties, 'cmd', 'Admin', 'arg', $l;
-                  push @properties, 'bytes', length($properties[-1]);
-                  $found_arg++;
+                  if ( $l =~ /^\s*[A-Z][a-z_]+: / ) {
+                     PTDEBUG && _d("Found NULL query before", $l);
+                     local $INPUT_RECORD_SEPARATOR = ";\n#";
+                     my $rest_of_event = $next_event->();
+                     push @{$self->{pending}}, $l . $rest_of_event;
+                     push @properties, 'cmd', 'Query', 'arg', '/* No query */';
+                     push @properties, 'bytes', 0;
+                     $found_arg++;
+                  }
+                  else {
+                     chomp $l;
+                     $l =~ s/^\s+//;
+                     PTDEBUG && _d("Found admin statement", $l);
+                     push @properties, 'cmd', 'Admin', 'arg', $l;
+                     push @properties, 'bytes', length($properties[-1]);
+                     $found_arg++;
+                  }
                }
                else {
                   PTDEBUG && _d("I can't figure out what to do with this line");
@@ -1890,7 +1901,8 @@
                $cmd = $arg;
             }
             else {
-               my ($user, undef, $db) = $arg =~ /(\S+)/g;
+               my ($user) = $arg =~ m/(\S+)/;
+               my ($db)   = $arg =~ m/on (\S+)/;
                my $host;
                ($user, $host) = split(/@/, $user);
                PTDEBUG && _d('Connect', $user, '@', $host, 'on', $db);
@@ -2907,6 +2919,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -8713,6 +8728,6 @@
 
 =head1 VERSION
 
-pt-query-advisor 2.1.7
+pt-query-advisor 2.1.8
 
 =cut

=== modified file 'bin/pt-query-digest'
--- bin/pt-query-digest	2012-12-11 14:48:44 +0000
+++ bin/pt-query-digest	2012-12-21 17:38:09 +0000
@@ -64,7 +64,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -1769,6 +1769,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -17424,6 +17427,6 @@
 
 =head1 VERSION
 
-pt-query-digest 2.1.7
+pt-query-digest 2.1.8
 
 =cut

=== modified file 'bin/pt-show-grants'
--- bin/pt-show-grants	2012-12-03 03:48:11 +0000
+++ bin/pt-show-grants	2012-12-21 17:38:09 +0000
@@ -2304,6 +2304,6 @@
 
 =head1 VERSION
 
-pt-show-grants 2.1.7
+pt-show-grants 2.1.8
 
 =cut

=== modified file 'bin/pt-sift'
--- bin/pt-sift	2012-11-19 18:47:13 +0000
+++ bin/pt-sift	2012-12-21 17:38:09 +0000
@@ -781,7 +781,7 @@
 
 =head1 VERSION
 
-pt-sift 2.1.7
+pt-sift 2.1.8
 
 =cut
 

=== modified file 'bin/pt-slave-delay'
--- bin/pt-slave-delay	2012-12-03 03:48:11 +0000
+++ bin/pt-slave-delay	2012-12-21 17:38:09 +0000
@@ -36,7 +36,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -2268,6 +2268,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -4598,6 +4601,6 @@
 
 =head1 VERSION
 
-pt-slave-delay 2.1.7
+pt-slave-delay 2.1.8
 
 =cut

=== modified file 'bin/pt-slave-find'
--- bin/pt-slave-find	2012-12-03 03:48:11 +0000
+++ bin/pt-slave-find	2012-12-21 17:38:09 +0000
@@ -3175,6 +3175,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -4022,6 +4025,6 @@
 
 =head1 VERSION
 
-pt-slave-find 2.1.7
+pt-slave-find 2.1.8
 
 =cut

=== modified file 'bin/pt-slave-restart'
--- bin/pt-slave-restart	2012-12-12 00:27:57 +0000
+++ bin/pt-slave-restart	2012-12-21 17:38:09 +0000
@@ -37,7 +37,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -5519,6 +5519,6 @@
 
 =head1 VERSION
 
-pt-slave-restart 2.1.7
+pt-slave-restart 2.1.8
 
 =cut

=== modified file 'bin/pt-stalk'
--- bin/pt-stalk	2012-12-11 14:55:34 +0000
+++ bin/pt-stalk	2012-12-21 17:38:09 +0000
@@ -71,7 +71,7 @@
 usage() {
    local file="$1"
 
-   local usage=$(grep '^Usage: ' "$file")
+   local usage="$(grep '^Usage: ' "$file")"
    echo $usage
    echo
    echo "For more information, 'man $TOOL' or 'perldoc $file'."
@@ -1984,7 +1984,7 @@
 
 =head1 VERSION
 
-pt-stalk 2.1.7
+pt-stalk 2.1.8
 
 =cut
 

=== modified file 'bin/pt-summary'
--- bin/pt-summary	2012-11-19 18:47:13 +0000
+++ bin/pt-summary	2012-12-21 17:38:09 +0000
@@ -78,7 +78,7 @@
 usage() {
    local file="$1"
 
-   local usage=$(grep '^Usage: ' "$file")
+   local usage="$(grep '^Usage: ' "$file")"
    echo $usage
    echo
    echo "For more information, 'man $TOOL' or 'perldoc $file'."
@@ -2673,7 +2673,7 @@
 
 =head1 VERSION
 
-pt-summary 2.1.7
+pt-summary 2.1.8
 
 =cut
 

=== modified file 'bin/pt-table-checksum'
--- bin/pt-table-checksum	2012-12-20 23:05:06 +0000
+++ bin/pt-table-checksum	2012-12-21 17:38:09 +0000
@@ -53,7 +53,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -7360,6 +7360,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -11954,6 +11957,6 @@
 
 =head1 VERSION
 
-pt-table-checksum 2.1.7
+pt-table-checksum 2.1.8
 
 =cut

=== modified file 'bin/pt-table-sync'
--- bin/pt-table-sync	2012-12-20 23:05:06 +0000
+++ bin/pt-table-sync	2012-12-21 17:38:09 +0000
@@ -52,7 +52,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -8036,6 +8036,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -12633,6 +12636,6 @@
 
 =head1 VERSION
 
-pt-table-sync 2.1.7
+pt-table-sync 2.1.8
 
 =cut

=== modified file 'bin/pt-table-usage'
--- bin/pt-table-usage	2012-12-04 22:42:14 +0000
+++ bin/pt-table-usage	2012-12-21 17:38:09 +0000
@@ -7384,6 +7384,6 @@
 
 =head1 VERSION
 
-pt-table-usage 2.1.7
+pt-table-usage 2.1.8
 
 =cut

=== modified file 'bin/pt-tcp-model'
--- bin/pt-tcp-model	2012-12-03 03:48:11 +0000
+++ bin/pt-tcp-model	2012-12-21 17:38:09 +0000
@@ -1216,6 +1216,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -2529,6 +2532,6 @@
 
 =head1 VERSION
 
-pt-tcp-model 2.1.7
+pt-tcp-model 2.1.8
 
 =cut

=== modified file 'bin/pt-trend'
--- bin/pt-trend	2012-12-03 03:48:11 +0000
+++ bin/pt-trend	2012-12-21 17:38:09 +0000
@@ -1736,6 +1736,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -2230,6 +2233,6 @@
 
 =head1 VERSION
 
-pt-trend 2.1.7
+pt-trend 2.1.8
 
 =cut

=== modified file 'bin/pt-upgrade'
--- bin/pt-upgrade	2012-12-19 16:47:54 +0000
+++ bin/pt-upgrade	2012-12-21 17:38:09 +0000
@@ -58,7 +58,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -2174,6 +2174,9 @@
                      . (defined $f ? '%09.6f' : '%02d'),
                      $y + 2000, $m, $d, $h, $i, (defined $f ? $s + $f : $s);
    }
+   elsif ( $val =~ m/^$proper_ts$/ ) {
+      return $val;
+   }
    return $val;
 }
 
@@ -2498,14 +2501,25 @@
 
             if ( !$found_arg && $pos == $len ) {
                PTDEBUG && _d("Did not find arg, looking for special cases");
-               local $INPUT_RECORD_SEPARATOR = ";\n";
+               local $INPUT_RECORD_SEPARATOR = ";\n";  # get next line
                if ( defined(my $l = $next_event->()) ) {
-                  chomp $l;
-                  $l =~ s/^\s+//;
-                  PTDEBUG && _d("Found admin statement", $l);
-                  push @properties, 'cmd', 'Admin', 'arg', $l;
-                  push @properties, 'bytes', length($properties[-1]);
-                  $found_arg++;
+                  if ( $l =~ /^\s*[A-Z][a-z_]+: / ) {
+                     PTDEBUG && _d("Found NULL query before", $l);
+                     local $INPUT_RECORD_SEPARATOR = ";\n#";
+                     my $rest_of_event = $next_event->();
+                     push @{$self->{pending}}, $l . $rest_of_event;
+                     push @properties, 'cmd', 'Query', 'arg', '/* No query */';
+                     push @properties, 'bytes', 0;
+                     $found_arg++;
+                  }
+                  else {
+                     chomp $l;
+                     $l =~ s/^\s+//;
+                     PTDEBUG && _d("Found admin statement", $l);
+                     push @properties, 'cmd', 'Admin', 'arg', $l;
+                     push @properties, 'bytes', length($properties[-1]);
+                     $found_arg++;
+                  }
                }
                else {
                   PTDEBUG && _d("I can't figure out what to do with this line");
@@ -13158,6 +13172,6 @@
 
 =head1 VERSION
 
-pt-upgrade 2.1.7
+pt-upgrade 2.1.8
 
 =cut

=== modified file 'bin/pt-variable-advisor'
--- bin/pt-variable-advisor	2012-12-03 03:48:11 +0000
+++ bin/pt-variable-advisor	2012-12-21 17:38:09 +0000
@@ -40,7 +40,7 @@
 # ###########################################################################
 {
 package Percona::Toolkit;
-our $VERSION = '2.1.7';
+our $VERSION = '2.1.8';
 
 1;
 }
@@ -5870,6 +5870,6 @@
 
 =head1 VERSION
 
-pt-variable-advisor 2.1.7
+pt-variable-advisor 2.1.8
 
 =cut

=== modified file 'bin/pt-visual-explain'
--- bin/pt-visual-explain	2012-12-04 22:42:14 +0000
+++ bin/pt-visual-explain	2012-12-21 17:38:09 +0000
@@ -3143,6 +3143,6 @@
 
 =head1 VERSION
 
-pt-visual-explain 2.1.7
+pt-visual-explain 2.1.8
 
 =cut

=== modified file 'config/deb/changelog'
--- config/deb/changelog	2012-11-19 18:47:13 +0000
+++ config/deb/changelog	2012-12-21 17:38:09 +0000
@@ -1,3 +1,36 @@
+percona-toolkit (2.1.8) unstable; urgency=low
+
+  * Fixed bug 1086259: pt-kill --log-dsn timestamp is wrong
+  * Fixed bug 1082104: pt-deadlock-logger problem when the user have a dash in the name
+  * Fixed bug 1079341: pt-online-schema-change checks for foreign keys on myisam tables.
+  * Fixed bug 1078887: Don't clobber the sql_mode set by the script with set-vars
+  * Fixed bug 1078838: pt-query-digest doesn't parse general log with "Connect user as user"
+  * Fixed bug 1075638: Illegal division by zero at pt-table-checksum line 7950
+  * Fixed bug 1074179: pt-table-checksum does't ignore tables for --replicate-check-only
+  * Fixed bug 1052475: pt-table-checksum uninitialized value in numeric lt (<) at line 8611.
+  * Fixed bug 911385: pt-table-checksum v2 fails when --resume + --ignore-database is used
+  * Fixed bug 1046440: pt-stalk purge_samples slows down checks
+  * Fixed bug 1041391: Debug statement for Chosen hash func prints undef
+  * Fixed bug 1007938: MySQLConfig doesn't support end-of-line comments
+  * Fixed bug 1022622: pt-config-diff is case-sensitive
+  * Fixed bug 917770: Use of uninitialized value in substitution (s///) at pt-config-diff line 1996
+  * Fixed bug 1015590: pt-mysql-summary not Percona Server 5.5-ready
+  * Fixed bug 996069: Incorrect RES.001
+  * Fixed bug 986847: pt-stalk does not report NFS iostat
+  * Fixed bug 887638: pt-query-digest prints negative byte offset
+  * Fixed bug 831525: pt-query-digest help output mangled
+  * Fixed bug 957442: pt-query-digest with custom --group-by throws error
+  * Fixed bug 1082599: pt-query-digest fails to parse timestamp with no query
+  * Fixed bug 823431: pt-query-advisor hangs on big queries
+  * Fixed bug 937234: pt-query-advisor issues wrong RES.001
+  * Fixed bug 933465: pt-query-advisor false positive on RES.001
+  * Fixed bug 932614: pt-slave-restart CHANGE MASTER query causes error
+  * Fixed bug 927955: bad pod2rst transformation
+  * Fixed bug 898665: Online docs formatting --[no]vars incorrectly
+  * Fixed bug 886059: pt-heartbeat handles timezones inconsistently
+
+ -- Percona Toolkit Developers <toolkit-dev@percona.com>  Fri, 21 Dec 2012 17:31:09 +0000
+
 percona-toolkit (2.1.7) unstable; urgency=low
 
   * Fixed bug 1080384: pt-table-checksum 2.1.6 crashes using PTDEBUG

=== modified file 'config/sphinx-build/conf.py'
--- config/sphinx-build/conf.py	2012-11-19 18:47:13 +0000
+++ config/sphinx-build/conf.py	2012-12-21 17:38:09 +0000
@@ -50,7 +50,7 @@
 # The short X.Y version.
 version = '2.1'
 # The full version, including alpha/beta/rc tags.
-release = '2.1.7'
+release = '2.1.8'
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.

=== modified file 'docs/percona-toolkit.pod'
--- docs/percona-toolkit.pod	2012-11-19 18:47:13 +0000
+++ docs/percona-toolkit.pod	2012-12-21 17:38:09 +0000
@@ -510,6 +510,6 @@
 
 =head1 VERSION
 
-Percona Toolkit v2.1.7 released 2012-11-19
+Percona Toolkit v2.1.8 released 2012-12-21
 
 =cut

=== modified file 'docs/release_notes.rst'
--- docs/release_notes.rst	2012-11-19 18:47:13 +0000
+++ docs/release_notes.rst	2012-12-21 17:38:09 +0000
@@ -1,6 +1,87 @@
 Release Notes
 *************
 
+v2.1.8 released 2012-12-21
+==========================
+
+Percona Toolkit 2.1.8 has been released.  This release includes 28 bug fixes, beta support for MySQL 5.6, and extensive support for Percona XtraDB Cluster (PXC); Users intending on running the tools on Percona XtraDB Cluster or MySQL 5.6 should strongly consider upgrading. The following tools have been verified to work on PXC versions 5.5.28 and newer:
+
+* pt-table-chcecksum
+
+* pt-online-schema-change
+
+* pt-archive
+
+* pt-mysql-summary
+
+* pt-heartbeat
+
+* pt-variable-advisor
+
+* pt-config-diff
+
+* pt-deadlock-logger
+
+Although there are some limitations: See the Percona XtraDB Cluster section in each tool's documentation for further details. All other tools, with the exception of pt-slave-find, pt-slave-delay and pt-slave-restart, should also work correctly, but in some cases they have not been modified to take advantage of PXC features, so they may behave differently in future releases.
+
+The bug fixes are widely assorted.  The following highlights some of the more interesting and "hot" bugs:
+
+* Fixed bug 1082599: pt-query-digest fails to parse timestamp with no query
+
+Logs which include timestamps with no query -- which can occasionally happen, for example, if using the slow_query_log_timestamp_always in Percona Server -- were misparsed, resulting in an erroneous report.
+
+* Fixed bug 1078838: pt-query-digest doesn't parse general log with "Connect user as user"
+
+The "as" was misparsed and the following word would end up reported as the database; pt-query-digest now handles this correctly.
+
+* Fixed bug 1015590: pt-mysql-summary not Percona Server 5.5-ready
+
+Some renamed variables had caused the Percona Server section to work unreliably.
+
+* Fixed bug 917770: Use of uninitialized value in substitution (s///) at pt-config-diff line 1996
+
+This was the hottest bug affecting a tool in the tracker.
+
+* Fixed bug 886059: pt-heartbeat handles timezones inconsistently
+
+Another 'hot' bug: Previously pt-heartbeat occasionally respected MySQL timezones, but sometimes it ignored them and used the system time instead. This generally wouldn't be troublesome, but resulted in erroneous reports for servers with slaves running in different timezones.
+
+2.1.8 continues the trend of solid bug fix releases, and all 2.1 users are encouraged to upgrade.
+
+Percona Toolkit packages can be downloaded from http://www.percona.com/downloads/percona-toolkit/ or the Percona Software Repositories (http://www.percona.com/software/repositories/).
+
+Changelog
+---------
+
+* Fixed bug 1086259: pt-kill --log-dsn timestamp is wrong
+* Fixed bug 1082104: pt-deadlock-logger problem when the user have a dash in the name
+* Fixed bug 1079341: pt-online-schema-change checks for foreign keys on myisam tables.
+* Fixed bug 1078887: Don't clobber the sql_mode set by the script with set-vars
+* Fixed bug 1078838: pt-query-digest doesn't parse general log with "Connect user as user"
+* Fixed bug 1075638: Illegal division by zero at pt-table-checksum line 7950
+* Fixed bug 1074179: pt-table-checksum does't ignore tables for --replicate-check-only
+* Fixed bug 1052475: pt-table-checksum uninitialized value in numeric lt (<) at line 8611.
+* Fixed bug 911385: pt-table-checksum v2 fails when --resume + --ignore-database is used
+* Fixed bug 1046440: pt-stalk purge_samples slows down checks
+* Fixed bug 1041391: Debug statement for Chosen hash func prints undef
+* Fixed bug 1007938: MySQLConfig doesn't support end-of-line comments
+* Fixed bug 1022622: pt-config-diff is case-sensitive
+* Fixed bug 917770: Use of uninitialized value in substitution (s///) at pt-config-diff line 1996
+* Fixed bug 1015590: pt-mysql-summary not Percona Server 5.5-ready
+* Fixed bug 996069: Incorrect RES.001
+* Fixed bug 986847: pt-stalk does not report NFS iostat
+* Fixed bug 887638: pt-query-digest prints negative byte offset
+* Fixed bug 831525: pt-query-digest help output mangled
+* Fixed bug 957442: pt-query-digest with custom --group-by throws error
+* Fixed bug 1082599: pt-query-digest fails to parse timestamp with no query
+* Fixed bug 823431: pt-query-advisor hangs on big queries
+* Fixed bug 937234: pt-query-advisor issues wrong RES.001
+* Fixed bug 933465: pt-query-advisor false positive on RES.001
+* Fixed bug 932614: pt-slave-restart CHANGE MASTER query causes error
+* Fixed bug 927955: bad pod2rst transformation
+* Fixed bug 898665: Online docs formatting --[no]vars incorrectly
+* Fixed bug 886059: pt-heartbeat handles timezones inconsistently
+
 v2.1.7 released 2012-11-19
 ==========================
 

